<template>
	<div class="ext-wikilambda-pagination">
		<cdx-button class="ext-wikilambda-pagination__view-all" @click="resetView">
			{{ buttonText }}
		</cdx-button>
		<div class="ext-wikilambda-pagination__page-selector">
			<div class="ext-wikilambda-pagination__page-selector__main">
				<input
					class="ext-wikilambda-pagination__page-selector__input"
					:max="totalPages"
					:value="currentPage"
					@input="resetPage( $event )"
				>
				<span class="ext-wikilambda-pagination__page-selector__total-pages">
					/ {{ totalPages }}
				</span>
			</div>
			<cdx-button
				class="ext-wikilambda-pagination__page-selector__action"
				:disabled="currentPage === 1"
				aria-label="Previous Page"
				@click="updatePage( -1 )"
			>
				<cdx-icon :icon="cdxIconPrevious" />
			</cdx-button>
			<cdx-button
				class="ext-wikilambda-pagination__page-selector__action"
				:disabled="currentPage === totalPages "
				aria-label="Next Page"
				@click="updatePage( 1 )"
			>
				<cdx-icon :icon="cdxIconNext" />
			</cdx-button>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent, computed } from 'vue';
import { CdxButton, CdxIcon } from '@wikimedia/codex';
import { cdxIconNext, cdxIconPrevious } from '@wikimedia/codex-icons';

export default defineComponent( {
	name: 'PaginationComponent',
	components: {
		'cdx-button': CdxButton,
		'cdx-icon': CdxIcon
	},
	props: {
		totalPages: {
			type: Number,
			required: true
		},
		currentPage: {
			type: Number,
			required: false,
			default: 1
		},
		showingAll: {
			type: Boolean,
			default: false
		}
	},
	emits: [
		'update-page',
		'reset-view'
	],
	setup( props, context ) {
		function updatePage( direction: number ) {
			context.emit( 'update-page', props.currentPage + direction );
		}

		function resetPage( e: Event ) {
			const target = e.target as HTMLInputElement;
			const numericInput = Number( target.value );

			if ( isNaN( numericInput ) ) {
				return; // do nothing if the input is not a valid number
			} else {
				// if input number is too low set to 1 and if it is too high set to last page
				if ( numericInput < 1 ) {
					context.emit( 'update-page', 1 );
				} else if ( numericInput > props.totalPages ) {
					context.emit( 'update-page', props.totalPages );
				} else {
					context.emit( 'update-page', numericInput );
				}
			}
		}

		function resetView() {
			context.emit( 'reset-view' );
		}

		const buttonText = computed( () => {
			if ( !props.showingAll ) {
				return 'View All';
			} else {
				return 'View Less';
			}
		} );

		return {
			cdxIconNext,
			cdxIconPrevious,
			resetPage,
			updatePage,
			buttonText,
			resetView
		};
	}
} );
</script>

<style lang="less">
.ext-wikilambda-pagination {
	padding-top: 8px;
	padding-bottom: 18px;
	display: flex;

	&__view-all {
		flex: none;
		height: 32px;
	}

	&__page-selector {
		display: flex;
		align-content: center;
		margin-left: auto;

		&__input {
			width: 32px;
			height: 32px;
			margin: 0;
			text-align: center;
			border: 1px solid #a2a9b1;
			border-radius: 2px;
		}

		&__total-pages {
			height: 32px;
			text-align: center;
			padding: 0 6px;
		}

		&__action {
			padding-left: 0;
			padding-right: 0;
			margin-left: 8px;
		}
	}
}
</style>
